src/Entity/Kinder.php
<?php

declare(strict_types=1);

/*
 * This file is part of the Arnapou Kinders package.
 *
 * (c) Arnaud Buathier <arnaud@arnapou.net>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace App\Entity;

use App\Exception\KinderVirtualException;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection as DoctrineCollection;
use Doctrine\Common\Collections\Criteria;
use Doctrine\Common\Collections\ReadableCollection;
use Doctrine\Common\Collections\Selectable;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: \App\Repository\KinderRepository::class)]
#[ORM\Index(columns: ['created_at'], name: 'created_at')]
#[ORM\Index(columns: ['updated_at'], name: 'updated_at')]
#[ORM\Index(columns: ['realsorting'], name: 'realsorting')]
#[ORM\Index(columns: ['slug'], name: 'slug')]
#[ORM\Index(columns: ['name'], name: 'name')]
#[ORM\Index(columns: ['quantity_owned'], name: 'quantity_owned')]
#[ORM\Index(columns: ['quantity_double'], name: 'quantity_double')]
#[ORM\Index(columns: ['reference'], name: 'reference')]
#[ORM\Index(columns: ['looking_for'], name: 'looking_for')]
#[ORM\Index(columns: ['year'], name: 'year')]
class Kinder extends BaseItem
{
    final public const BPZS_SORTING = ['name' => 'ASC'];
    final public const ZBAS_SORTING = ['name' => 'ASC'];

    #[ORM\OneToMany(mappedBy: 'kinder', targetEntity: BPZ::class, orphanRemoval: true)]
    private DoctrineCollection $bpzs;

    #[ORM\OneToMany(mappedBy: 'kinder', targetEntity: ZBA::class, orphanRemoval: true)]
    private DoctrineCollection $zbas;

    #[ORM\ManyToOne(targetEntity: Serie::class, fetch: 'EAGER', inversedBy: 'kinders')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Serie $serie = null;

    #[ORM\ManyToOne(targetEntity: self::class, fetch: 'EAGER', inversedBy: 'virtuals')]
    private ?Kinder $original = null;

    #[ORM\OneToMany(targetEntity: self::class, mappedBy: 'original')]
    private DoctrineCollection $virtuals;

    public function __construct()
    {
        parent::__construct();
        $this->bpzs = new ArrayCollection();
        $this->zbas = new ArrayCollection();
        $this->virtuals = new ArrayCollection();
    }

    public function getBpzs(): ReadableCollection
    {
        if ($this->bpzs instanceof Selectable) {
            $criteria = Criteria::create()->orderBy(self::BPZS_SORTING);

            return $this->bpzs->matching($criteria);
        }

        return $this->bpzs;
    }

    public function getZbas(): ReadableCollection
    {
        if ($this->zbas instanceof Selectable) {
            $criteria = Criteria::create()->orderBy(self::ZBAS_SORTING);

            return $this->zbas->matching($criteria);
        }

        return $this->zbas;
    }

    public function getSerie(): ?Serie
    {
        return $this->serie;
    }

    public function setSerie(Serie $serie): self
    {
        $this->serie = $serie;

        return $this;
    }

    public function getOriginal(): ?self
    {
        return $this->original;
    }

    public function setOriginal(self $original): self
    {
        if ($original->getId() === $this->getId()) {
            throw new KinderVirtualException('Le kinder ne peut pas être virtuel de lui-même.');
        }
        if ($original->isVirtual()) {
            throw new KinderVirtualException("Le kinder ne peut pas être virtuel d'un autre virtuel.");
        }
        if ($this->hasVirtuals()) {
            throw new KinderVirtualException('Le kinder ne peut pas être virtuel car il a déjà des virtuels de lui-même.');
        }
        $this->original = $original;

        return $this;
    }

    public function getVirtuals(): DoctrineCollection
    {
        return $this->virtuals;
    }

    public function isVirtual(): bool
    {
        return (bool) $this->original;
    }

    public function getAttributes(array $types = []): ReadableCollection
    {
        return $this->original ? $this->original->getAttributes($types) : parent::getAttributes($types);
    }

    public function getImage(int $num = 0): ?Image
    {
        return $this->original ? $this->original->getImage($num) : parent::getImage($num);
    }

    public function getImages(): ReadableCollection
    {
        return $this->original ? $this->original->getImages() : parent::getImages();
    }

    public function getComment(): string
    {
        return parent::getComment() ?: ($this->original ? $this->original->getComment() : '');
    }

    public function getDescription(): string
    {
        return parent::getDescription() ?: ($this->original ? $this->original->getDescription() : '');
    }

    public function getVariante(): string
    {
        return parent::getVariante() ?: ($this->original ? $this->original->getVariante() : '');
    }

    private function hasVirtuals(): bool
    {
        return !$this->virtuals->isEmpty();
    }
}

src/Entity/Serie.php
<?php

declare(strict_types=1);

/*
 * This file is part of the Arnapou Kinders package.
 *
 * (c) Arnaud Buathier <arnaud@arnapou.net>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection as DoctrineCollection;
use Doctrine\Common\Collections\Criteria;
use Doctrine\Common\Collections\ReadableCollection;
use Doctrine\Common\Collections\Selectable;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: \App\Repository\SerieRepository::class)]
#[ORM\Index(columns: ['created_at'], name: 'created_at')]
#[ORM\Index(columns: ['updated_at'], name: 'updated_at')]
#[ORM\Index(columns: ['realsorting'], name: 'realsorting')]
#[ORM\Index(columns: ['slug'], name: 'slug')]
#[ORM\Index(columns: ['name'], name: 'name')]
#[ORM\Index(columns: ['quantity_owned'], name: 'quantity_owned')]
#[ORM\Index(columns: ['quantity_double'], name: 'quantity_double')]
#[ORM\Index(columns: ['reference'], name: 'reference')]
#[ORM\Index(columns: ['looking_for'], name: 'looking_for')]
#[ORM\Index(columns: ['year'], name: 'year')]
class Serie extends BaseItem
{
    final public const KINDER_SORTING = ['realsorting' => 'ASC', 'name' => 'ASC'];
    final public const PIECES_SORTING = ['realsorting' => 'ASC', 'name' => 'ASC'];
    final public const ITEMS_SORTING = ['realsorting' => 'ASC', 'name' => 'ASC'];

    #[ORM\ManyToOne(targetEntity: Catalog::class, fetch: 'EAGER')]
    #[ORM\JoinColumn(nullable: true)]
    private ?Catalog $catalog = null;

    #[ORM\Column(type: 'string', length: 100)]
    private string $catalogPage = '';

    #[ORM\ManyToOne(targetEntity: Country::class, fetch: 'EAGER')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Country $country = null;

    /** @var DoctrineCollection<int, Kinder> */
    #[ORM\OneToMany(mappedBy: 'serie', targetEntity: Kinder::class, orphanRemoval: true)]
    private DoctrineCollection $kinders;

    /** @var DoctrineCollection<int, Piece> */
    #[ORM\OneToMany(mappedBy: 'serie', targetEntity: Piece::class, orphanRemoval: true)]
    private DoctrineCollection $pieces;

    /** @var DoctrineCollection<int, Item> */
    #[ORM\OneToMany(mappedBy: 'serie', targetEntity: Item::class, orphanRemoval: true)]
    private DoctrineCollection $items;

    #[ORM\ManyToOne(targetEntity: Collection::class, fetch: 'EAGER', inversedBy: 'series')]
    private ?Collection $collection = null;

    public function __construct()
    {
        parent::__construct();
        $this->kinders = new ArrayCollection();
        $this->items = new ArrayCollection();
        $this->pieces = new ArrayCollection();
    }

    public function getCountry(): ?Country
    {
        return $this->country;
    }

    public function setCountry(Country $country): self
    {
        $this->country = $country;

        return $this;
    }

    public function getCatalog(): ?Catalog
    {
        return $this->catalog;
    }

    public function setCatalog(?Catalog $catalog): self
    {
        $this->catalog = $catalog;

        return $this;
    }

    public function getMaxBpzCount(): int
    {
        $max = 0;
        foreach ($this->kinders as $kinder) {
            $max = max($max, $kinder->getBpzs()->count());
        }

        return $max;
    }

    public function getMaxZbaCount(): int
    {
        $max = 0;
        foreach ($this->kinders as $kinder) {
            $max = max($max, $kinder->getZbas()->count());
        }

        return $max;
    }

    public function getKinders(): ReadableCollection
    {
        if ($this->kinders instanceof Selectable) {
            $criteria = Criteria::create()->orderBy(self::KINDER_SORTING);

            return $this->kinders->matching($criteria);
        }

        return $this->kinders;
    }

    public function getPieces(): ReadableCollection
    {
        if ($this->pieces instanceof Selectable) {
            $criteria = Criteria::create()->orderBy(self::PIECES_SORTING);

            return $this->pieces->matching($criteria);
        }

        return $this->pieces;
    }

    public function addPiece(Piece $piece): self
    {
        if (!$this->pieces->contains($piece)) {
            $this->pieces[] = $piece;
            $piece->setSerie($this);
        }

        return $this;
    }

    public function removePiece(Piece $piece): self
    {
        if ($this->pieces->contains($piece)) {
            $this->pieces->removeElement($piece);
            // set the owning side to null (unless already changed)
            if ($piece->getSerie() === $this) {
                $piece->setSerie(null);
            }
        }

        return $this;
    }

    public function getItems(): ReadableCollection
    {
        if ($this->items instanceof Selectable) {
            $criteria = Criteria::create()->orderBy(self::ITEMS_SORTING);

            return $this->items->matching($criteria);
        }

        return $this->items;
    }

    public function addItem(Item $item): self
    {
        if (!$this->items->contains($item)) {
            $this->items[] = $item;
            $item->setSerie($this);
        }

        return $this;
    }

    public function removeItem(Item $item): self
    {
        if ($this->items->contains($item)) {
            $this->items->removeElement($item);
            // set the owning side to null (unless already changed)
            if ($item->getSerie() === $this) {
                $item->setSerie(null);
            }
        }

        return $this;
    }

    public function getCollection(): ?Collection
    {
        return $this->collection;
    }

    public function setCollection(?Collection $collection): self
    {
        $this->collection = $collection;

        return $this;
    }

    public function isPuzzle(): bool
    {
        return $this->hasAttribute('kinder', 'Puzzle');
    }

    public function getPuzzle(): ?array
    {
        if (!$this->isPuzzle()) {
            return null;
        }
        $kinders = [];
        $w = $h = 0;
        foreach ($this->kinders as $kinder) {
            foreach ($kinder->getAttributes() as $attribute) {
                if ($attribute instanceof Attribute
                    && 'puzzle' === strtolower($attribute->getType())
                    && preg_match('!^(\d+):(\d+)$!', $attribute->getName(), $matches)
                ) {
                    $x = (int) $matches[2];
                    $y = (int) $matches[1];
                    $kinders[$y - 1][$x - 1] = $kinder;

                    $w = max($w, $x);
                    $h = max($h, $y);
                }
            }
        }

        return [
            'width' => $w,
            'height' => $h,
            'kinders' => $kinders,
        ];
    }

    public function getImage(int $num = 0): ?Image
    {
        foreach ($this->getKinders() as $kinder) {
            if ($kinder instanceof BaseItem && $image = $kinder->getImage()) {
                return $image;
            }
        }

        return null;
        // $image = parent::getImage($num);
        // if (0 === $num && null === $image) {
        //     foreach ($this->getKinders() as $kinder) {
        //         if ($image = $kinder->getImage()) {
        //             break;
        //         }
        //     }
        // }
        //
        // return $image;
    }

    public function isComplete(): bool
    {
        foreach ($this->getKinders() as $kinder) {
            if ($kinder instanceof Kinder) {
                if ($kinder->isLookingFor()) {
                    return false;
                }
                foreach ($kinder->getBpzs() as $bpz) {
                    if ($bpz instanceof BaseItem && $bpz->isLookingFor()) {
                        return false;
                    }
                }
                foreach ($kinder->getZbas() as $zba) {
                    if ($zba instanceof BaseItem && $zba->isLookingFor()) {
                        return false;
                    }
                }
            }
        }

        return true;
    }

    public function getCatalogPage(): string
    {
        return $this->catalogPage;
    }

    public function setCatalogPage(string $catalogPage): void
    {
        $this->catalogPage = $catalogPage;
    }
}

templates/front/base.html.twig
<!doctype html>
<html lang="fr">
<head>
    <meta charset="utf-8">

    <title>{{- block('title') -}}</title>
    <link rel="icon" href="{{ asset('favicon.ico') }}"/>

    {% block stylesheets %}
        <link href="{{ asset('front.css'|assetbuilder) }}" rel="stylesheet">
    {% endblock %}
</head>
<body>

<div id="menu">
    {% block menu %}
        <a href="{{ path('front_home') }}" class="logo">
            <img src="{{ asset('wiki.png') }}">
        </a>

        {%- if is_granted('ROLE_ADMIN') -%}
            {{ 'ADMIN' -}}
            <ul class="admin">
                <li><a href="{{ path('admin_menucategs_add') }}">Ajouter une catégorie</a></li>
                <li><a href="{{ path('admin_menuitems_add') }}">Ajouter un lien</a></li>
                <li><a href="{{ path('admin_series') }}">Séries</a></li>
            </ul>
        {%- endif -%}

        {%- for categ in frontmenu.categories -%}
            {{- categ.name -}}
            <ul>
                {% set limit=10 %}
                {%- for item in categ.items|slice(0, limit) -%}
                    <li><a href="{{ item.url }}">{{ item.name }}</a></li>
                {%- endfor -%}
                {% if categ.items|length > limit %}
                    <li><a href="#" class="more_menu_items">... voir plus ...</a></li>
                    {%- for item in categ.items|slice(limit) -%}
                        <li style="display: none"><a href="{{ item.url }}">{{ item.name }}</a></li>
                    {%- endfor -%}
                {% endif %}
            </ul>
        {% endfor %}
    {% endblock %}
</div>

<div id="content">
    <h1>
        {%- block h1_wrapper -%}
            {%- block title -%}
                {%- if menuitem is not empty -%}
                    {{- menuitem.name -}}
                {%- endif -%}
            {%- endblock -%}
        {%- endblock -%}
    </h1>
    {%- block content -%}
    {%- endblock -%}
</div>

<div class="clearfix"></div>

<div id="footer">
    {%- block footer -%}
        &copy; {{ 'now'|date('Y') }} &mdash; Elodie Buathier &mdash; <a href="mailto:kinder@arnapou.net">✉ Contact</a>
    {%- endblock -%}
</div>

{% block javascripts %}
    <script src="{{ asset('front.js'|assetbuilder) }}"></script>
{% endblock %}
</body>
</html>

templates/front/collection.html.twig
{% extends "base.html.twig" %}

{% block title -%}
    {{ collection.name }}
{%- endblock %}

{% block content %}

    {% for serie in collection.series %}
        {{ block('serie_kinders', 'serie.html.twig') }}
    {% endfor %}

    {% for serie in collection.series %}
        {{ block('serie_pieces', 'serie.html.twig') }}
    {% endfor %}

{% endblock %}

templates/front/index.html.twig
{% extends "base.html.twig" %}

{% block title -%}
    Les Kinders d'Arnapou
{%- endblock %}

{% block content %}

    <div class="row ">
        <div class="col">
            {{ frontmenu.confighome.description|raw|internalLinks }}
        </div>
        <div class="col-3 text-right">
            <img src="{{ path('random_kinder_image') }}" alt="" class="img-thumbnail">
        </div>
    </div>

    <div class="mt-5"></div>

    {%- for categ in frontmenu.categories(false) -%}
        <div class="home-menu border rounded mr-3 mb-3">
            <div class="title border-bottom">{{- categ.name -}}</div>
            <ul>
                {%- for item in categ.items -%}
                    <li><a href="{{ item.url }}">{{ item.name }}</a></li>
                {%- endfor -%}
            </ul>
        </div>
    {% endfor %}

{% endblock %}

templates/front/listing.html.twig
{% extends "base.html.twig" %}

{% block h1_wrapper -%}
    {{- parent() -}}
    {%- if link_pdf -%}
        <a href="{{ link_pdf }}" target="_blank" class="pdf-download">
            <img src="{{ asset('icon-pdf.png') }}" alt="">Télécharger le PDF
        </a>
    {%- endif -%}
{%- endblock %}

{% block content %}
    {% import "macros.html.twig" as macro %}

    {% set total_kinder = 0 %}
    {% set total_bpzs = 0 %}
    {% set total_zbas = 0 %}

    <table class="kinders">
        <thead>
        <tr>
            <th>Pays</th>
            <th>Année</th>
            <th>Série</th>
            <th>Kinder</th>
            <th>BPZ</th>
            <th>ZBA</th>
            {%- if is_granted('ROLE_ADMIN') -%}
                <th></th>
            {%- endif -%}
        </tr>
        </thead>
        <tbody>
        {%- for serie in series -%}
            {%- set total_kinder = total_kinder + (serie.stats.kinder ?? 0) %}
            {%- set total_bpzs = total_bpzs + (serie.stats.bpz ?? 0) %}
            {%- set total_zbas = total_zbas + (serie.stats.zba ?? 0) -%}
            <tr>
                <td class="country">{{ macro.flag(serie.country) }} {{ serie.country }}</td>
                <td>{{ serie.year }}</td>
                <td class="imageserie">
                    <a href="{{ path('front_serie', {id: serie.id, slug: serie.slug}) }}" class="{{ serie.complete ? '' : 'text-danger' }}">
                        {{- macro.imageserie(serie) -}}
                        {{- serie.name -}}
                    </a>
                </td>
                <td class="text-center">{% if serie.stats.kinder %}{{ serie.stats.kinder }}{% endif %}</td>
                <td class="text-center">{% if serie.stats.bpz %}{{ serie.stats.bpz }}{% endif %}</td>
                <td class="text-center">{% if serie.stats.zba %}{{ serie.stats.zba }}{% endif %}</td>
                {%- if is_granted('ROLE_ADMIN') -%}
                    <td>
                        <a href="{{ path('admin_series_view', {id: serie.id}) }}" class="btn-sm btn-danger">
                            <i class="fas fa-pen"></i>
                        </a>
                    </td>
                {%- endif -%}
            </tr>
        {%- endfor -%}
        </tbody>
        <tfoot>
        <tr>
            <td colspan="3" class="text-right text-muted">Total</td>
            <td class="text-center">{{ total_kinder }}</td>
            <td class="text-center">{{ total_bpzs }}</td>
            <td class="text-center">{{ total_zbas }}</td>
            {%- if is_granted('ROLE_ADMIN') -%}
                <td></td>
            {%- endif -%}
        </tr>
        </tfoot>
    </table>

{% endblock %}

templates/front/search.html.twig
{% extends "base.html.twig" %}

{% block h1_wrapper -%}
    {% if is_granted('ROLE_ADMIN') -%}
        <a href="{{ path('admin_series') }}" class="float-right btn btn-danger">
            <i class="fas fa-bars"></i> Séries
        </a>
    {%- endif %}
    {{ parent() }}
{%- endblock %}

{% block content %}

    {% for collection in collections -%}
        {% if collection.id -%}
            <h2 class="mt-4">
                <a href="{{ path('front_collection', {id: collection.id, slug: collection.slug}) }}">
                    {{ collection }}
                </a>
            </h2>
        {%- endif %}
        {{- _self.table_series(collection.series) -}}
    {% endfor %}

{% endblock %}

{% macro table_series(series, notid) %}
    {% import "macros.html.twig" as macro %}
    <table class="kinders series">
        <thead>
        <tr>
            <th>Pays</th>
            <th>Année</th>
            <th>Série</th>
            {%- if is_granted('ROLE_ADMIN') -%}
                <th>Complet</th>
                <th></th>
            {%- endif -%}
        </tr>
        </thead>
        <tbody>
        {%- for serie in series -%}
            {% if serie.id != notid -%}
                <tr>
                    <td class="country">{{ macro.flag(serie.country) }} {{ serie.country }}</td>
                    <td>{{ serie.year }}</td>
                    <td class="imageserie">
                        <a href="{{ path('front_serie', {id: serie.id, slug: serie.slug}) }}" class="{{ serie.complete ? '' : 'text-danger' }}">
                            {{- macro.imageserie(serie) -}}
                            {{- serie.name -}}
                        </a>
                    </td>
                    {%- if is_granted('ROLE_ADMIN') -%}
                        {%- if serie.complete -%}
                            <td class="text-center text-primary"><i class="fas fa-check"></i></td>
                        {%- else -%}
                            <td class="text-center text-danger"><i class="fas fa-times"></i></td>
                        {%- endif -%}
                        <td>
                            <a href="{{ path('admin_series_view', {id: serie.id}) }}" class="btn-sm btn-danger">
                                <i class="fas fa-pen"></i>
                            </a>
                        </td>
                    {%- endif -%}
                </tr>
            {%- endif %}
        {%- endfor -%}
        </tbody>
    </table>
{% endmacro %}

templates/front/serie.html.twig
{% extends "base.html.twig" %}

{% block title -%}
    {{ serie.name }}{% if serie.year %} &ndash; {{ serie.year }}{% endif %}
{%- endblock %}

{% block h1_wrapper %}
    {% if is_granted('ROLE_ADMIN') -%}
        <a href="{{ path('admin_series_view', {id: serie.id}) }}" class="float-right btn btn-danger">
            <i class="fas fa-pen"></i>
        </a>
    {%- endif -%}
    {{ parent() }}
{% endblock %}

{% block content %}

    {{ block('serie_header') }}
    {{ block('serie_kinders') }}
    {{ block('serie_pieces') }}
    {{ block('serie_items') }}
    {{ block('serie_collection') }}
    {{ block('serie_attributes') }}

{% endblock %}

{% block serie_collection %}
    {% import "search.html.twig" as search %}

    {% if serie.collection and serie.collection.series|length > 1 %}
        <h2 class="mt-5">Autres séries liées</h2>
        {{ search.table_series(serie.collection.series, serie.id) }}
    {% endif %}
{% endblock %}

{% block serie_header %}
    {% if serie.description %}
        <p>
            {{- serie.description|nl2br|internalLinks -}}
        </p>
    {% endif %}
{% endblock %}

{% block serie_kinders %}
    {% import "macros.html.twig" as macro %}

    <h2 class="mt-5">
        {%- if collection is defined -%}
            {{ macro.flag(serie.country) }} {{ serie.country }} : {{ serie.name }} &ndash; {{ serie.year }}
            {% if is_granted('ROLE_ADMIN') %}
                <a href="{{ path('admin_series_view', {id: serie.id}) }}" class="ml-5 btn btn-danger">
                    <i class="fas fa-pen"></i>
                </a>
            {% endif %}
        {%- else -%}
            {{ macro.flag(serie.country) }} {{ serie.country }}
        {%- endif -%}
    </h2>
    {% set puzzle = serie.puzzle %}
    {{ block('serie_puzzle') }}
    {% if serie.kinders|length == 0 %}
        <p class="alert alert-secondary">
            Aucune figurine dans cette série 🙁
        </p>
    {% else %}
        {% set maxBpz = serie.maxBpzCount %}
        {% set maxZba = serie.maxZbaCount %}
        <table class="kinders">
            <thead>
            <tr>
                <th>Référence</th>
                <th>Nom</th>
                <th>Photos</th>
                {%- if maxBpz -%}
                    <th colspan="{{ maxBpz }}">BPZ</th>
                {%- endif -%}
                {%- if maxZba -%}
                    <th colspan="{{ maxZba }}">ZBA</th>
                {%- endif %}
            </tr>
            </thead>
            <tbody>
            {%- for kinder in serie.kinders -%}
                <tr>
                    <td class="text-center">{{ kinder.reference ?: '' }}</td>
                    <td>
                        {{ kinder.name }}
                        {%- if kinder.variante -%}
                            <p class="text-muted variante">
                                Variante : {{ kinder.variante -}}
                            </p>
                        {%- endif -%}
                    </td>
                    <td class="image">
                        {{- macro.images(kinder) -}}
                        {{- macro.status(kinder) -}}
                    </td>
                    {{- _self.td_images(kinder.bpzs, maxBpz) -}}
                    {{- _self.td_images(kinder.zbas, maxZba) -}}
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {% endif %}
{% endblock %}

{% block serie_puzzle %}
    {% import "macros.html.twig" as macro %}

    {% if puzzle -%}
        <table class="puzzle mt-3 mb-3">
            <tbody>
            {%- for y in 1..puzzle.height -%}
                <tr>
                    {%- for x in 1..puzzle.width -%}
                        {% set kinder = puzzle.kinders[y-1][x-1] ?? none %}
                        {%- if kinder and kinder.image -%}
                            <td class="image">
                                {{- macro.images(kinder) -}}
                            </td>
                        {%- else -%}
                            <td class="empty">
                                <span class="mr-2 ml-2">{{ y }}:{{ x }}</span>
                            </td>
                        {%- endif -%}
                    {%- endfor -%}
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {%- endif %}
{% endblock %}

{% block serie_pieces %}
    {% import "macros.html.twig" as macro %}

    {% if serie.pieces|length %}
        {% set refs = serie|kinderRefs %}
        <h2 class="mt-5">
            {%- if collection is defined %}{{ macro.flag(serie.country) }} {{ serie.country }} : {% endif %}Pièces détachées
        </h2>
        <table class="kinders">
            <thead>
            <tr>
                <th>Référence</th>
                <th>Nom</th>
                <th>Pièce</th>
                <th>Photos</th>
                <th>Tags</th>
            </tr>
            </thead>
            <tbody>
            {%- for piece in serie.pieces -%}
                <tr>
                    <td class="text-center">{{ piece.reference ?: '' }}</td>
                    <td>{{ refs[piece.reference] ?? '' }}</td>
                    <td>{{ piece.name }}</td>
                    <td class="image">
                        {{- macro.images(piece) -}}
                        {{- macro.status(piece) -}}
                    </td>
                    <td>
                        {{- macro.attributes(piece) -}}
                    </td>
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {% endif %}
{% endblock %}

{% block serie_items %}
    {% import "macros.html.twig" as macro %}

    {% if serie.items|length %}
        {% set refs = serie|kinderRefs %}
        <h2 class="mt-5">
            {%- if collection is defined %}{{ macro.flag(serie.country) }} {{ serie.country }} : {% endif %}Objets
        </h2>
        <table class="kinders">
            <thead>
            <tr>
                <th>Référence</th>
                <th>Nom</th>
                <th>Objet</th>
                <th>Photos</th>
                <th>Tags</th>
            </tr>
            </thead>
            <tbody>
            {%- for item in serie.items -%}
                <tr>
                    <td class="text-center">{{ item.reference ?: '' }}</td>
                    <td>{{ refs[item.reference] ?? '' }}</td>
                    <td>{{ item.name }}</td>
                    <td class="image">
                        {{- macro.images(item) -}}
                        {{- macro.status(item) -}}
                    </td>
                    <td>
                        {{- macro.attributes(item) -}}
                    </td>
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {% endif %}
{% endblock %}

{% block serie_attributes %}
    {% import "macros.html.twig" as macro %}

    {% if serie.attributes|length -%}
        <p class="mt-5 kinder">
            Tags : {{ macro.attributes(serie) -}}
        </p>
    {%- endif %}

    {%- if serie.catalog -%}
        <p class="mt-1 kinder">
            Catalogue :
            <span class="attribute">
                <span>{{ serie.catalog~(serie.catalogPage ? ' - '~serie.catalogPage : '') }}</span>
            </span>
        </p>
    {%- endif -%}
{% endblock %}

{% macro td_images(images, max) -%}
    {% import "macros.html.twig" as macro %}

    {% if max %}
        {% for img in images -%}
            <td class="image">
                {{- macro.images(img) -}}
                {{- macro.status(img) -}}
            </td>
        {% endfor %}
        {% if max - images|length %}
            {%- for i in 1..(max - images|length) -%}
                <td>&nbsp;</td>
            {%- endfor -%}
        {% endif %}
    {% endif %}
{%- endmacro %}